<!DOCTYPE html>
<html lang="en">

<head>
  <title>task 41.10 Filter Users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    "use strict";
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gUsersArr = [];
      //khai báo cột 
      const gDATA_COLUMN = [
        //gán với tên các cột của array
        "id",
        "firstname",
        "lastname",
        "country",
        "subject",
        "registerStatus",
        "customerType",
        "action",
      ];

      const gCOLUMN_ID = 0;
      const gCOLUMN_FIRST_NAME = 1;
      const gCOLUMN_LAST_NAME = 2;
      const gCOLUMN_COUNTRY = 3;
      const gCOLUMN_SUBJECT = 4;
      const gCOLUMN_REGISTERED_STATUS = 5;
      const gCOLUMN_CUSTOMER_TYPE = 6;
      const gCOLUMN_ACTION = 7;

      // định nghĩa table  - chưa có data
      var gUserTable = $("#user-table").DataTable({
        // Khai báo các cột của datatable
        columns: [
          { data: gDATA_COLUMN[gCOLUMN_ID] },
          { data: gDATA_COLUMN[gCOLUMN_FIRST_NAME] },
          { data: gDATA_COLUMN[gCOLUMN_LAST_NAME] },
          { data: gDATA_COLUMN[gCOLUMN_COUNTRY] },
          { data: gDATA_COLUMN[gCOLUMN_SUBJECT] },
          { data: gDATA_COLUMN[gCOLUMN_REGISTERED_STATUS] },
          { data: gDATA_COLUMN[gCOLUMN_CUSTOMER_TYPE] },
          { data: gDATA_COLUMN[gCOLUMN_ACTION] }
        ],
        // Ghi đè nội dung của cột action, chuyển thành button chi tiết
        columnDefs: [
          {
            targets: gCOLUMN_ACTION,
            defaultContent: "<button class='info-user btn btn-info'>Chi tiết</button>"
          }]
      });

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();

      // gán click event handler cho button chi tiet
      $("#user-table").on("click", ".info-user", function () {
        onButtonChiTietClick(this); // this là button được ấn
      });

      //gán event handler click và hàm thực thi khi nhấn nút Filter
      $("#btn-filter").on("click", onBtnFilterClick);


      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // infoFunction sẽ là function các nút cùng gọi
      function onButtonChiTietClick(paramChiTietButton) {
        //Xác định thẻ tr là cha của nút được chọn
        var vRowSelected = $(paramChiTietButton).parents('tr');
        //Lấy datatable row
        var vDatatableRow = gUserTable.row(vRowSelected);
        //Lấy data của dòng 
        var vUserData = vDatatableRow.data();
        var vId = vUserData.id;
        var vFirstname = vUserData.firstname;
        var vLastname = vUserData.lastname;
        var vCountry = vUserData.country;

        console.log(vId);
        console.log(vFirstname);
        console.log(vLastname);
        console.log(vCountry);
      }

      // hàm chạy khi trang được load
      function onPageLoading() {
        // lấy data từ server
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
          type: "GET",
          dataType: 'json',
          success: function (responseObject) {
            //debugger;
            loadDataToTable(responseObject);
            gUsersArr = responseObject;
          },
          error: function (error) {
            console.assert(error.responseText);
          }
        });
      }


      //hàm xử lý sự kiện khi nhấn nút filter
      function onBtnFilterClick(params) {
        "use strict";
        // tạo đối tượng 
        var vFilterObj = {
          firstname: "",
          lastname: ""
        }
        //b1 thu thập dữ liệu
        readData(vFilterObj);
        //b3: validate (k cần)
        //b4: thực hiện việc tìm kiếm và hiển thị
        debugger;
        var vArrUserFiltered = findUserByFilter(vFilterObj);
        var vTable = $("#table-users"); //truy vấn đến bảng có id = table-users
        vTable.find("tr:gt(0)").html(''); //xóa trắng bảng (k xóa header)
        if (vArrUserFiltered.length > 0) {
          //hiện thông báo đã tìm được
          alert("Tìm thấy " + vArrUserFiltered.length + " kết quả phù hợp");
          //hiển thị danh sách dữ liệu tìm được ra table
          loadDataToTable(vArrUserFiltered);
        }
        else {
          alert("Không tìm thấy kết quả phù hợp");
          return false;
        }

      }




      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
      // load data to table
      function loadDataToTable(paramResponseObject) {
        //Xóa toàn bộ dữ liệu đang có của bảng
        gUserTable.clear();
        //Cập nhật data cho bảng 
        gUserTable.rows.add(paramResponseObject);
        //Cập nhật lại giao diện hiển thị bảng
        gUserTable.draw();
      }

      //hàm thu thập dữ liệu
      function readData(paramKeyWordObj) {
        "use strict";
        var vInpFirstName = $("#firstNameInput");
        var vInpLastName = $("#lastNameInput");
        paramKeyWordObj.firstname = $.trim(vInpFirstName.val());
        paramKeyWordObj.lastname = $.trim(vInpLastName.val());

      }

      function findUserByFilter(paramKeyWordObj) {
        "use strict";
        const bArrResultObj = [];
        //kiểm tra truồng hợp nếu FirstName và Lastname đề được nhập
        if (paramKeyWordObj.firstname != "" && paramKeyWordObj.lastname != "") {
          for (let bI = 0; bI < gUsersArr.length; bI++) {
            const bItemUserObj = gUsersArr[bI];
            //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
            if (paramKeyWordObj.firstname.toLowerCase() === bItemUserObj.firstname.toLowerCase() && paramKeyWordObj.lastname.toLowerCase() === bItemUserObj.lastname.toLowerCase()) {
              //thêm đối tượng thỏa mãn điều kiện vào array
              bArrResultObj.push(bItemUserObj);
            }
          }
        }

        //kiểm tra trường hợp nếu FN hoặc LN được nhập
        if (paramKeyWordObj.firstname != "" || paramKeyWordObj.lastname != "") {
          for (let bI = 0; bI < gUsersArr.length; bI++) {
            const bItemUserObj = gUsersArr[bI];
            //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
            if (paramKeyWordObj.firstname.toLowerCase() === bItemUserObj.firstname.toLowerCase() ||
              paramKeyWordObj.lastname.toLowerCase() === bItemUserObj.lastname.toLowerCase()) {
              //thêm đối tượng thỏa mãn điều kiện vào array
              bArrResultObj.push(bItemUserObj);
            }
          }
        }
        return bArrResultObj;
      }


    });



  </script>
</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">Danh sách đăng ký</h2>
    <div class="jumbotron container">
      <div class="row form-group">
        <label class="col-sm-2 col-form-label" for="firstNameInput">First name</label>
        <div class="col-sm-3">
          <input type="text" id="firstNameInput" class="form-control" placeholder="Nhap first name ...">
        </div>
        <label class="col-sm-2 col-form-label" for="lastNameInput">Last name</label>
        <div class="col-sm-3">
          <input type="text" id="lastNameInput" class="form-control" placeholder="Nhap last name ...">
        </div>
        <div class="col-sm-2">
          <button class="btn btn-success" id="btn-filter">Filter user</button>
        </div>
      </div>
    </div>

    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
    </table>
  </div>

</body>

</html>